<?php

$p=explode(basename(_DIR_PLUGINS)."/",str_replace('\\','/',realpath(dirname(__FILE__))));
$z = explode('/',end($p));
define('_DIR_PUBEMAIL',(_DIR_PLUGINS.stripslashes($z[0])));

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/texte');
charger_generer_url();

function exec_pubemail_admin()
{
	echo debut_page();

	// Zone d'explication sur le fonctionnement du plugin
	echo debut_gauche();
	echo debut_cadre_relief(_DIR_PUBEMAIL.'/images/ico-lampe.png', true, "", _T('pubemail:intro'));
  	echo _T("pubemail:Avec ce plugin, Spip pourra accepter des saisies d'article par lecture d'emails formatés.
		<p>Les pièces jointes ne sont pas acceptées. Le format doit être du texte pur.
		<p>Spip se connectera selon les paramètres donnés pour le serveur POP. 
		Il utilisera un serveur SMTP si le champ est renseigné pour accuser réception des 
		emails reçus.
		<p>Les articles seront créés dans la rubrique et avec l'apppartenance qui auront été
		définis dans l'entête formatée de l'email. Cependant, si ces paramètres ne peuvent pas
		être décodés dans l'email, alors une rubrique par défaut sera utilisée ainsi qu'un auteur
		par défaut.
		<p>Les emails envoyés doivent avoir dans le champ 'sujet' le code 'SPIPOUNET'.
		Le format du texte doit être le suivant par exemple:
		<p>#titre:Ceci est le titre de l'article
		<p>#rubrique:Rubrique destinée à réception des emails
		<p>#mot-cle:6,9
		<p>#lang:fr
		<p>#texte:{{Titre}}Voici le corps de l'article
		<p>qui se continue sur autant de lignes que nécessaires.
	");

  	echo fin_cadre_relief(true);

	// Zone de configuration
	echo debut_droite();
	gros_titre(_T("pubemail:page_administration"));
    debut_boite_info();
    echo "Publication d'article par email. Développé sur SPIP 1.9.2e";
	//    echo "Un formulaire simple. Si rien n'est demandé en modification, donne le formulaire d'encodage.
    fin_boite_info();
		
	// affiche le bouton de lecture des emails
	echo debut_cadre_trait_couleur(_DIR_PUBEMAIL."/images/ico-pubemail.png", true, "", _T('pubemail:Lire_les_messages'));
	echo "<form action='".generer_url_ecrire('pubemail_lire')."' method='post'>\n";
	echo "<br /><input type='submit' value='"._T("pubemail:Lire_les_messages")."' class='fondo' />";
	echo "</form>";
	echo fin_cadre_trait_couleur();
 
	// Formulaire de configuration
	pubemail_formulaire();

	echo fin_gauche();
	echo fin_page();
}

function pubemail_formulaire()
{
	global $connect_statut, $connect_id_auteur;

	// Valeurs des paramètres par défaut
	$serveur_pop="";
	$port_pop=110;
	$user="";
	$password="";
	$serveur_smtp="";
	$port_smtp=25;
	$domain="";
	$publie = 0;
	$purge_pop = 1;
	$rubrique = 1;
	$auteur = 1;
	$ack = 0;
	
	
	if ($connect_statut != "0minirezo" )
	{
		echo "<p><b>"._T('acces_a_la_page')."</b></p>";
		fin_page();
		exit;
	}

	// fonction qui traite les posts avant 'afficher la page
	traiter_posts();
		
	// formulaire de modification si modifier passe en get
	$resultat = spip_query("SELECT * FROM spip_pubemail");
	if(spip_num_rows($resultat))
	{
		$row=spip_fetch_array($resultat);
		$serveur_pop=$row['serveur_pop'];
		$port_pop=$row['port_pop'];
		$user=$row['user'];
		$password=$row['password'];
		$serveur_smtp=$row['serveur_smtp'];
		$port_smtp=$row['port_smtp'];
		$domain=$row['domain'];
		$publie=$row['publie'];
		$rubrique=$row['rubrique'];
		$purge_pop=$row['purge_pop'];
		$auteur=$row['auteur'];
		$ack=$row['acknowledge'];
	}

	// Affiche le formulaire d'entrée
	echo debut_cadre_trait_couleur(_DIR_PUBEMAIL."/images/ico-modifier.png", true, "", _T('pubemail:Configuration'));
   
	echo "<form action='".generer_url_ecrire('pubemail_admin')."' method='post'>\n";

	echo "<p><strong>"._T("pubemail:serveur_pop")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:60%' name='serveur_pop' value='".$serveur_pop."' /><br />";
	echo "</p>";
  
	echo "<p><strong>"._T("pubemail:port_pop")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:10%' name='port_pop' value='".$port_pop."' /><br />";
	echo "</p>";

	echo "<p><strong>"._T("pubemail:user")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' name='user' style='width:20%' value='".$user."' /><br />";
	echo "</p>";
  
	echo "<p><strong>"._T("pubemail:password")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' name='password' style='width:20%' value='".$password."' /><br />";
	echo "</p>";
	
	echo "<p><strong>"._T("pubemail:serveur_smtp")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:60%' name='serveur_smtp' value='".$serveur_smtp."' /><br />";
	echo "</p>";
  
	echo "<p><strong>"._T("pubemail:port_smtp")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:10%' name='port_smtp' value='".$port_smtp."' /><br />";
	echo "</p>";

	echo "<p><strong>"._T("pubemail:domaine_smtp")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:60%' name='domain' value='".$domain."' /><br />";
	echo "</p>";

	echo "<p><strong>"._T("pubemail:Les_mails_doivent_ils_etre_supprimes_du_serveur:")."&nbsp;&nbsp;</strong>";
	echo "<input type='radio' name='purge_pop' value='1' ";
	if($purge_pop == true)
		echo "checked";
	echo "/>Oui&nbsp;&nbsp;&nbsp;";
	echo "<input type='radio' name='purge_pop' value='0' ";
	if($purge_pop == false)
		echo "checked";
	echo "/>Non";
	echo "</p>";
	
	echo "<p><strong>"._T("pubemail:Statut_des_articles_envoyés:")."&nbsp;&nbsp;</strong>";
	echo "<input type='radio' name='publie' value='0' ";
	if($publie==0)
		echo " checked";
	echo "/>Proposé&nbsp;&nbsp;&nbsp;";
	echo "<input type='radio' name='publie' value='1' ";
	if($publie==1)
		echo " checked";	
	echo ">Publié";
	echo "</p>";

	echo "<p><strong>"._T("pubemail:Faut_il_accuser_reception:")."&nbsp;&nbsp;</strong>";
	echo "<input type='radio' name='ack' value='1' ";
	if($ack == true)
		echo "checked";
	echo "/>Oui&nbsp;&nbsp;&nbsp;";
	echo "<input type='radio' name='ack' value='0' ";
	if($ack == false)
		echo "checked";
	echo "/>Non";
	echo "</p>";
	
	echo "<p><strong>"._T("pubemail:rubrique_par_defaut")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:10%' name='rubrique' value='".$rubrique."' /><br />";
	echo "</p>";

	echo "<p><strong>"._T("pubemail:auteur_par_defaut")."&nbsp;&nbsp;&nbsp;&nbsp;</strong>";
	echo "<input type='text' style='width:10%' name='auteur' value='".$auteur."' /><br />";
	echo "</p>";

	echo "<input type='hidden' name='action' value='modifier' />";

	echo "<br /><input type='submit' value='"._T("arty:enregistrer")."' class='fondo' />";
	echo "</form>";

	echo fin_cadre_trait_couleur();	
}

function traiter_posts()
{
	$serveur_pop=addslashes($_POST['serveur_pop']);
	$port_pop=(int) $_POST['port_pop'];
	$serveur_smtp=addslashes($_POST['serveur_smtp']);
	$port_smtp=(int) $_POST['port_smtp'];
	$user=addslashes($_POST['user']);
	$password=addslashes($_POST['password']);
	$domain=addslashes($_POST['domain']);
	$purge_pop=addslashes($_POST['purge_pop']);
	$publie=addslashes($_POST['publie']);
	$rubrique=addslashes($_POST['rubrique']);
	$auteur=addslashes($_POST['auteur']);
	$ack=addslashes($_POST['ack']);

	$action = $_POST['action'];
	if($action=='modifier')
	{
		spip_query("DELETE FROM spip_pubemail;");	// Efface tous les enregistrements
		$action="entrer";
	}
	if($action=='entrer')
	{
		$champ = "serveur_pop, port_pop, user,password,serveur_smtp,port_smtp,domain,purge_pop,publie,rubrique,auteur,acknowledge";
		$valeurs = "VALUES ('$serveur_pop','$port_pop','$user','$password','$serveur_smtp','$port_smtp','$domain','$purge_pop',' $publie','$rubrique','$auteur','$ack')";
		spip_query("INSERT INTO spip_pubemail (".$champ.")".$valeurs);
	}
}	

 	function benDebug ($texte)
	{
 	  print "$texte <BR>";
 	  spip_log("[PUBEMAIL] $texte");
 	}

	
?>
